'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ReduxComponent = require('redux-components/lib/ReduxComponent');

var _ReduxComponent2 = _interopRequireDefault(_ReduxComponent);

var _action = require('redux-components/lib/decorators/action');

var _action2 = _interopRequireDefault(_action);

var _selector = require('redux-components/lib/decorators/selector');

var _selector2 = _interopRequireDefault(_selector);

var _arrify = require('arrify');

var _arrify2 = _interopRequireDefault(_arrify);

var _shallowEqual = require('nanotools/lib/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

var _isEmptyObject = require('nanotools/lib/isEmptyObject');

var _isEmptyObject2 = _interopRequireDefault(_isEmptyObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

const { assign } = Object;

function identity(x) {
  return x;
} // Higher-order component. Given functions for equality testing and identification
// of entities, create an entity store that stores opaque entities by id.

exports.default = function EntityStore(identify, serialize = identity, equalityTest = _shallowEqual2.default) {
  var _dec, _dec2, _dec3, _dec4, _desc, _value, _class, _class2, _temp;

  return _dec = (0, _action2.default)({ isDispatcher: true }), _dec2 = (0, _action2.default)({ isDispatcher: true }), _dec3 = (0, _action2.default)({ isDispatcher: true }), _dec4 = (0, _selector2.default)({ isObservable: true }), (_class = (_temp = _class2 = class _class extends _ReduxComponent2.default {

    reducer(state = {}, action) {
      if (action.type === this.UPDATE) {
        const updates = (() => {
          const _obj = {};for (let _arr = action.payload, _i = 0, _len = _arr.length; _i < _len; _i++) {
            const entity = _arr[_i];
            const id = identify(entity),
                  data = serialize(entity),
                  current = state[id];
            if (!current || !equalityTest(current, data)) _obj[id] = assign({}, current, data);
          }return _obj;
        })();
        if (!(0, _isEmptyObject2.default)(updates)) return assign({}, state, updates);else return state;
      } else if (action.type === this.DELETE) {
        let nextState = state;
        for (let _arr2 = action.payload, _i2 = 0, _len2 = _arr2.length; _i2 < _len2; _i2++) {
          const id = _arr2[_i2];if (nextState[id]) {
            if (nextState === state) nextState = Object.assign({}, state);
            delete nextState[id];
          }
        }return nextState;
      } else {
        return state;
      }
    }
    create(entities) {
      return { type: this.UPDATE, payload: (0, _arrify2.default)(entities) };
    }

    update(partialEntities) {
      return { type: this.UPDATE, payload: (0, _arrify2.default)(partialEntities) };
    }

    delete(ids) {
      return { type: this.DELETE, payload: (0, _arrify2.default)(ids) };
    }

    byId(state) {
      return state;
    }getById(id) {
      var _ref;

      return (_ref = this.state) == null ? null : _ref[id];
    }
  }, _class2.verbs = ['UPDATE', 'DELETE'], _temp), (_applyDecoratedDescriptor(_class.prototype, 'create', [_dec], Object.getOwnPropertyDescriptor(_class.prototype, 'create'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'update', [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, 'update'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'delete', [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, 'delete'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'byId', [_dec4], Object.getOwnPropertyDescriptor(_class.prototype, 'byId'), _class.prototype)), _class);
};