'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _dec, _dec2, _dec3, _desc, _value, _class, _class2, _temp;

var _ReduxComponent = require('redux-components/lib/ReduxComponent');

var _ReduxComponent2 = _interopRequireDefault(_ReduxComponent);

var _action = require('redux-components/lib/decorators/action');

var _action2 = _interopRequireDefault(_action);

var _selector = require('redux-components/lib/decorators/selector');

var _selector2 = _interopRequireDefault(_selector);

var _shallowEqual = require('nanotools/lib/shallowEqual');

var _shallowEqual2 = _interopRequireDefault(_shallowEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

// An ObjectStore is a state node that stores an object of which the reducer
// is shallowly aware. State changes are checked for shallow equality and
// payloads can be shallow merged.
let ObjectStore = (_dec = (0, _action2.default)({ isDispatcher: true }), _dec2 = (0, _action2.default)({ isDispatcher: true }), _dec3 = (0, _selector2.default)({ isObservable: true }), (_class = (_temp = _class2 = class ObjectStore extends _ReduxComponent2.default {

  reducer(state = {}, action) {
    if (action.type === this.SET) {
      if ((0, _shallowEqual2.default)(state, action.payload)) {
        return state;
      } else {
        return Object.assign({}, action.payload);
      }
    } else if (action.type === this.MERGE) {
      const maybeNextState = Object.assign({}, state, action.payload);
      if ((0, _shallowEqual2.default)(state, maybeNextState)) {
        return state;
      } else {
        return maybeNextState;
      }
    } else {
      return state;
    }
  }
  set(obj) {
    return { type: this.SET, payload: obj };
  }

  merge(obj) {
    return { type: this.MERGE, payload: obj };
  }

  get(state) {
    return state;
  }
}, _class2.verbs = ['SET', 'MERGE'], _temp), (_applyDecoratedDescriptor(_class.prototype, 'set', [_dec], Object.getOwnPropertyDescriptor(_class.prototype, 'set'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'merge', [_dec2], Object.getOwnPropertyDescriptor(_class.prototype, 'merge'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'get', [_dec3], Object.getOwnPropertyDescriptor(_class.prototype, 'get'), _class.prototype)), _class));
exports.default = ObjectStore;