'use strict';

var _chai = require('chai');

var _reduxComponents = require('redux-components');

var _EntityStore = require('../EntityStore');

var _EntityStore2 = _interopRequireDefault(_EntityStore);

var _makeStore = require('./helpers/makeStore');

var _makeStore2 = _interopRequireDefault(_makeStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('entity store', function () {
  let es, store;
  it('should create', function () {
    es = new ((0, _EntityStore2.default)(function (x) {
      return x.id;
    }))();
    store = (0, _makeStore2.default)();
    return (0, _reduxComponents.mountRootComponent)(store, es);
  });

  it('should update', function () {
    return es.update({ id: 1, value: 'one' });
  });

  it('should return same state when there are no changes', function () {
    es.update({ id: 1, value: 'two' });
    const state = es.state;
    es.update({ id: 1, value: 'two' });
    return (0, _chai.assert)(es.state === state);
  });

  return it('should delete', function () {
    es.update([{ id: 2, value: 'three' }, { id: 3, value: 'four' }]);
    _chai.assert.deepEqual(es.getById(2), { id: 2, value: 'three' });
    es.delete(2);
    (0, _chai.assert)(!es.getById(2));
    const state = es.state;
    es.delete(2);
    return (0, _chai.assert)(es.state === state);
  });
});